CREATE OR REPLACE FUNCTION del_serial_seq() RETURNS TRIGGER AS '
DECLARE
	seqname text;
BEGIN
	IF OLD.field_type=11 THEN
		seqname := ''tef_'' || CAST(OLD.tracker_extra_field_id AS text) || ''_seq'';
		IF EXISTS ( SELECT 1 FROM pg_class WHERE relname = seqname )  THEN
			EXECUTE ''DROP SEQUENCE '' || seqname;
		END IF;
	END IF;
	RETURN NULL;
END;'
LANGUAGE 'plpgsql';

CREATE OR REPLACE FUNCTION add_serial_seq() RETURNS TRIGGER AS '
BEGIN
	IF NEW.field_type= 11 THEN
		EXECUTE ''CREATE SEQUENCE '' || ''tef_'' || CAST(NEW.tracker_extra_field_id AS text) || ''_seq'';
	END IF;
	RETURN NULL;
END;'
LANGUAGE 'plpgsql';


