<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'my_report' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class MyReportMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.MyReportMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("my_report");
		$tMap->setPhpName("MyReport");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("my_report_my_report_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("MY_REPORT_ID", "MyReportId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("USER_ID", "UserId", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addColumn("REPORT_NAME", "ReportName", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("IS_SHARED", "IsShared", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("OPEN_DATE_START", "OpenDateStart", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("OPEN_DATE_END", "OpenDateEnd", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("CLOSE_DATE_START", "CloseDateStart", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("CLOSE_DATE_END", "CloseDateEnd", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("REPORT_TYPE", "ReportType", "int", CreoleTypes::INTEGER, false, null);
				
    }
}
