<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Marcelo Mottalli	<marcelo@gforgegroup.com>
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
 
require_once('SystemUtils.php');
require_once('GFConf.php');
 
/** 
 * Template class
 */
class ThemeFactory {
	private function __construct() {
	}
	
	/**
	 * @param	mixed $theme	Name of the theme or the Theme object from the database.
	 * @return	GFTheme
	 */
	public static function getTheme($theme) {
		// This prevents loading the GFTheme class multiple times. This may occur if the gf.php
		// script is processed BEFORE initializing the session (this happens for example on the SOAP
		// interface or the cronjobs, but it's not a problem since they don't use the themes at all)
		if (class_exists('GFTheme')) {
			return new GFTheme();
		}
		
		$themeName = $theme;
		
		// theme path is something like /(gforge_root_dir)/www/(themeName)
		$themePath = SystemUtils::buildFilePath(GFConf::get('system.libDir'), '/www/themes/'.$themeName);
		$themeFile = SystemUtils::buildFilePath($themePath, '/GFTheme.php');
		if (!is_dir($themePath)) {
			throw new Exception('Theme "'.$themeName.'" not found: '.$themePath.' is not a valid directory');
		} else if (!file_exists($themeFile)) {
			throw new Exception('Theme "'.$themeName.'" not found: '.$themeFile.' is not a valid file');
		}
		
		require_once($themeFile);
		if (!class_exists('GFTheme')) {
			throw new Exception($themeFile.' doesn\'t have a GFTheme class');
		}
		
		return new GFTheme();
	}
	
}
?>