<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once("session/DatabaseLogin.php");

/**
 * Selects which class we should use for logging in to the system
 */
class LoginFactory {
	/**
	 * @return Login
	 * @todo Implement!
	 */
	public function getLogin() {
		$ldap = GFConf::get('system.usesLdap');
		if ($ldap) { 
			// check that the plugin is enabled in the DB for the site too
			require_once('plugins/ldap/lib/LdapPlugin.php');
			$c = new Criteria();
			$c->add(PluginPeer::PLUGIN_NAME,LdapPlugin::NAME);
			$ldapplugin = PluginPeer::doSelectOne($c);
			if ($ldapplugin instanceof Plugin) {
				require_once('plugins/ldap/lib/LdapLogin.php');
				return new LdapLogin();
			} else {
				return new DatabaseLogin();
			}
		} else {
			return new DatabaseLogin();
		}
		
	}
}
?>