<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists Forum
//
require_once('plugins/forum/lib/ForumPeer.php');
require_once('plugins/forum/lib/Forum.php');
require_once('plugins/forum/lib/html/ForumAdminFormRenderer.php');
require_once('html/Paginator.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

$Project = GFUrl::getUrl()->getProject();

require_once('plugins/forum/lib/html/ForumAdminTemplate.php');
$theme = new ForumAdminTemplate();

$forum_id = (isset($_GET['id'])) ? intval($_GET['id']) : 0;
$forum = ForumPeer::retrieveByPk($forum_id);
if (!is_object($forum)) {
	throw new PermissionDeniedError();
}

$params = array(
		'project' => $Project,
		'forum' => $forum,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Forum.PendingMessageBrowsePageTitle')
		);

$theme->header($params);

//list of packages that you can access
$c = new Criteria();
//$c->add(ForumPeer::REF_ID,$Project->getPrimaryKey());
//$c->add(ForumPeer::SECTION, 'project');
$c->addJoin(ForumPeer::FORUM_ID, ForumThreadPeer::FORUM_ID, Criteria::JOIN);
$c->addJoin(ForumThreadPeer::FORUM_THREAD_ID, ForumMessagePeer::FORUM_THREAD_ID, Criteria::JOIN);
$c->add(ForumPeer::FORUM_ID, $forum_id);
$c->add(ForumMessagePeer::IS_APPROVED, false);
$c->addAscendingOrderByColumn(ForumMessagePeer::POST_DATE);
$messages = ForumMessagePeer::doSelect($c);

//$c->addJoin(ForumMessagePeer::CREATED_BY, UserPeer::USER_ID, Criteria::JOIN);

//print_r($messages);

$theader = array();

$theader[] = Language::getSessText('ForumMessage.Approve');
$theader[] = Language::getSessText('ForumMessage.Delete');
$theader[] = Language::getSessText('ForumMessage.NoAction');
$theader[] = Language::getSessText('ForumMessage.Poster');
$theader[] = Language::getSessText('ForumMessage.SubjectName');
$theader[] = Language::getSessText('ForumMessage.BodyName');



echo $theme->tableTop($theader);

if (count($messages) < 1) {
	echo $theme->tableFullRow($Lang->getText('ForumMessage.NoneFound'));
} else {
	echo '<form id="formmessages" action="'.GFUrl::getUrl()->currentBaseURL('PendingMessageBrowseAction').'" method="POST">';
	
	foreach ($messages as $message) {
		echo '<input type="hidden" name="message['.$message->getForumMessageId().']" value="" />';
		//Obtain message poster
		$c1 = new Criteria();
		$c1->add(UserPeer::USER_ID, $message->getCreatedBy());
		$user = UserPeer::doSelectOne($c1);

		$trow = array();	
		$trow[] = '<input type="radio" name="message['.$message->getForumMessageId().'][action]" value="approve">';
		$trow[] = '<input type="radio" name="message['.$message->getForumMessageId().'][action]" value="delete">';
		$trow[] = '<input type="radio" name="message['.$message->getForumMessageId().'][action]" value="noaction" checked="checked">';
		$trow[] = $user->getUnixName();
		$trow[] = $message->getSubject();
		$trow[] = $message->getBody();
		
		$tmod[] = '';
		echo $theme->tableRow($trow,$tmod, true);

	}
}

echo $theme->tableBottom();
if (count($messages) >= 1) {
	echo HTMLWidget::button("submit",$Lang->getText('submit.edit'),"submit","");
}
echo HTMLWidget::button("button",$Lang->getText('Common.Back'),"cancel","","window.location='".GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'','forum','admin',array())."';");

echo '</form>';
$theme->footer($params);
?>
