<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'scm_user_stats' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.scm.lib.map
 */
class ScmUserStatsMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.scm.lib.map.ScmUserStatsMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("scm_user_stats");
		$tMap->setPhpName("ScmUserStats");
		
         
		$tMap->setUseIdGenerator(false);
		 
						
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("STAT_DATE", "StatDate", "int", CreoleTypes::DATE, true);
		$tMap->addForeignPrimaryKey("PROJECT_ID", "ProjectId", "int" , CreoleTypes::INTEGER, "project", "PROJECT_ID", true);
		$tMap->addForeignPrimaryKey("USER_ID", "UserId", "int" , CreoleTypes::INTEGER, "user", "USER_ID", true);
		$tMap->addColumn("CHECKOUTS", "Checkouts", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addColumn("COMMITS", "Commits", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addColumn("ADDS", "Adds", "int", CreoleTypes::INTEGER, true, null);
				
    }
}
