<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';

include_once 'plugins/scm/lib/ScmPreferencePeer.php';

/**
 * Base class that represents a row from the 'scm_preference' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to ScmPreference class. 
 * 
 * @package plugins.scm.lib 
 */
abstract class BaseScmPreference extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var ScmPreferencePeer
	 */
	protected static $peer;

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the require_tracker_item_id field.
	 * @var boolean	  
	 */
	protected $require_tracker_item_id = false;	

	/**
	 * The value for the mail_commits field.
	 * @var boolean	  
	 */
	protected $mail_commits = false;	
  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = ScmPreferencePeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the RequireTrackerItemId column value.
	 *  
	 * @return boolean	  
	 */
	public function getRequireTrackerItemId()
	{
		return $this->require_tracker_item_id;
	}


	/**
	 * Set the value of `require_tracker_item_id` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setRequireTrackerItemId($v)
	{
		if ($this->require_tracker_item_id !== $v || $v === false) {
			$this->require_tracker_item_id = $v;
			$this->modifiedColumns[] = ScmPreferencePeer::REQUIRE_TRACKER_ITEM_ID;
		}
				
	}

  
	/**
	 * Get the MailCommits column value.
	 *  
	 * @return boolean	  
	 */
	public function getMailCommits()
	{
		return $this->mail_commits;
	}


	/**
	 * Set the value of `mail_commits` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setMailCommits($v)
	{
		if ($this->mail_commits !== $v || $v === false) {
			$this->mail_commits = $v;
			$this->modifiedColumns[] = ScmPreferencePeer::MAIL_COMMITS;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->project_id = $rs->getInt($startcol + 0);					
			$this->require_tracker_item_id = $rs->getBoolean($startcol + 1);					
			$this->mail_commits = $rs->getBoolean($startcol + 2);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating ScmPreference object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(ScmPreferencePeer::DATABASE_NAME);
		$criteria->add(ScmPreferencePeer::PROJECT_ID, $this->project_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(ScmPreferencePeer::DATABASE_NAME);
		if ($this->isColumnModified(ScmPreferencePeer::PROJECT_ID)) $criteria->add(ScmPreferencePeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(ScmPreferencePeer::REQUIRE_TRACKER_ITEM_ID)) $criteria->add(ScmPreferencePeer::REQUIRE_TRACKER_ITEM_ID, $this->require_tracker_item_id);
		if ($this->isColumnModified(ScmPreferencePeer::MAIL_COMMITS)) $criteria->add(ScmPreferencePeer::MAIL_COMMITS, $this->mail_commits);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addScmPreferences($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("project_id", "require_tracker_item_id", "mail_commits", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case ScmPreferencePeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case ScmPreferencePeer::REQUIRE_TRACKER_ITEM_ID:
				return $this->getRequireTrackerItemId();
				break;
		  
			case ScmPreferencePeer::MAIL_COMMITS:
				return $this->getMailCommits();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getProjectId();
				break;
  
			case 1:
				return $this->getRequireTrackerItemId();
				break;
  
			case 2:
				return $this->getMailCommits();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(ScmPreferencePeer::PROJECT_ID, $arr)) $this->setProjectId($arr[ScmPreferencePeer::PROJECT_ID]);
  
		if (array_key_exists(ScmPreferencePeer::REQUIRE_TRACKER_ITEM_ID, $arr)) $this->setRequireTrackerItemId($arr[ScmPreferencePeer::REQUIRE_TRACKER_ITEM_ID]);
  
		if (array_key_exists(ScmPreferencePeer::MAIL_COMMITS, $arr)) $this->setMailCommits($arr[ScmPreferencePeer::MAIL_COMMITS]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case ScmPreferencePeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case ScmPreferencePeer::REQUIRE_TRACKER_ITEM_ID:
				$this->setRequireTrackerItemId($value);
				break;
	  
			case ScmPreferencePeer::MAIL_COMMITS:
				$this->setMailCommits($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setProjectId($value);
				break;
  
			case 1:
				$this->setRequireTrackerItemId($value);
				break;
  
			case 2:
				$this->setMailCommits($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(ScmPreferencePeer::DATABASE_NAME);

		try {
			$con->begin();
			ScmPreferencePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(ScmPreferencePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ScmPreferencePeer::doInsert($this, $con);
					$this->setNew(false);
				} else {
					ScmPreferencePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return ScmPreferencePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = ScmPreferencePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed project_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setProjectId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getProjectId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return ScmPreference Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new ScmPreference();
		$copyObj->setRequireTrackerItemId($this->require_tracker_item_id);
		$copyObj->setMailCommits($this->mail_commits);
		
		$copyObj->setNew(true);
		
		$copyObj->setProjectId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return ScmPreferencePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ScmPreferencePeer();
		}
		return self::$peer;
	}

}
