#!/usr/bin/php
<?php
require_once('initialize.php');
require_once('GFConf.php');
require_once('SystemUtils.php');
 
$cvsroot = GFConf::get('scmcvs.localCVSRoot');
if (!is_dir($cvsroot)) {
	echo 'CVSROOT dir '.$cvsroot.' doesn\'t exist'."\n";
	exit(1);
}

// Create the string to be passed as a parameter to the "cvs pserver" script
$allow_root_params = '';

$dh = opendir($cvsroot);
while ($dir = readdir($dh)) {
	$repository = SystemUtils::buildFilePath($cvsroot, $dir);
	if (preg_match('/^\\./', $dir) || $dir == 'cvs-locks' || !is_dir($repository)) {
		continue;
	}

	$allow_root_params .= '--allow-root='.$repository.' ';
}
closedir($dh);

$cvs_bin = GFConf::get('scmcvs.cvsbin');

$cmd = $cvs_bin.' -f '.$allow_root_params.' pserver';
passthru($cmd);
?>
