<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'tracker_extra_field_element_transition' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.tracker.lib.map
 */
class TrackerExtraFieldElementTransitionMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.tracker.lib.map.TrackerExtraFieldElementTransitionMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("tracker_extra_field_element_transition");
		$tMap->setPhpName("TrackerExtraFieldElementTransition");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("tracker_extra_field_element_t_tracker_extra_field_element_t_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("TRACKER_EXTRA_FIELD_ELEMENT_TRANSITION_ID", "TrackerExtraFieldElementTransitionId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("ELEMENT_ID", "ElementId", "int", CreoleTypes::INTEGER, "tracker_extra_field_element" , "ELEMENT_ID", true);
		$tMap->addForeignKey("TO_ELEMENT_ID", "ToElementId", "int", CreoleTypes::INTEGER, "tracker_extra_field_element" , "ELEMENT_ID", true);
		$tMap->addColumn("NOTIFICATION_MESSAGE", "NotificationMessage", "string", CreoleTypes::VARCHAR, false, null);
				
    }
}
