<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @author Ruben Gutierrez ruben@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerTemplate.php');
$theme = new TrackerTemplate();

$Project = GFUrl::getUrl()->getProject();
$tracker_id = Validator::sanitizeInt($_GET['tracker_id']);
$Tracker = TrackerPeer::retrieveByPk($tracker_id);
if (!$Tracker || !is_object($Tracker) || $Tracker->getProject()->getProjectId() != $Project->getProjectId() || !$Tracker->userCanRead()) {
        throw new PermissionDeniedException();
}

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Tracker.EmailGatewayTitle')
		);

$theme->header($params);

$hostname = GFConf::get('system.hostName');
$email_address = 'gforge-gateway@'.$hostname;
$start_date = date('m/d/Y');
$end_date = date('m/d/Y', time() + (10*86400));
?>
<p>
	<h1><?php echo $Lang->getText('Tracker.EmailGatewayTitle') ?></h1>
	<?php echo $Lang->getText('TrackerItem.GatewayInstructions', array($email_address, $tracker_id, $start_date, $end_date)); ?>
</p>

<?php
$theme->footer($params);
?>
