<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing TrackerQuery
//
require_once('plugins/tracker/lib/TrackerQueryPeer.php');
require_once('plugins/tracker/lib/TrackerQuery.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('plugins/tracker/lib/html/TrackerExtraFieldRenderer.php');
require_once('plugins/tracker/lib/TrackerItemSavedQuery.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerTemplate.php');
$theme = new TrackerTemplate();

//must be logged in
if (!$session->isLoggedIn()) {
      throw new NotLoggedInException();
}

$Project = GFUrl::getUrl()->getProject();
$Tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);
$tefr = new TrackerExtraFieldRenderer($Tracker);

$crit = new Criteria();
$crit->add(TrackerQueryPeer::USER_ID, $session->getUser()->getID());
$crit->add(TrackerQueryPeer::TRACKER_QUERY_ID,$_REQUEST['tracker_query_id']);
$arr = $Tracker->getTrackerQuerys($crit);
$obj=$arr[0];
if (!is_object($obj)) {
      throw new PermissionDeniedException();
}
$tq=new TrackerItemSavedQuery($Tracker,$obj);

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('TrackerQuery.EditPageTitle')
	);

//$tracker_id = ( (isset($_POST) && isset($_POST['tracker_id'])) ? htmlspecialchars($_POST['tracker_id']) : $obj->getTrackerId() );
$is_shared = ( (isset($_POST) && isset($_POST['is_shared'])) ? Validator::sanitizeBool($_POST['is_shared']) : $obj->getIsShared() );
$query_name = ( (isset($_POST) && isset($_POST['query_name'])) ? htmlspecialchars($_POST['query_name']) : $obj->getQueryName() );
$sortcol = ( (isset($_POST) && isset($_POST['sortcol'])) ? $_POST['sortcol'] : $tq->getSortCol() );
$sortord = ( (isset($_POST) && isset($_POST['sortord'])) ? $_POST['sortord'] : $tq->getSortOrd() );
//$is_selected = ( (isset($_POST) && isset($_POST['is_selected'])) ? htmlspecialchars($_POST['is_selected']) : $obj->getIsSelected() );

// Default values for the date fields

$mod = explode(' ',$tq->getModDateRange());
if (isset($_POST['moddatestart'])) {
	$moddatestart = htmlspecialchars($_POST['moddatestart']);
} elseif (count($mod) > 1) {
	$moddatestart = date('M d Y',strtotime($mod[0].' '.$mod[1].' '.$mod[2]));
} else {
	$moddatestart = '';
}
if (isset($_POST['moddateend'])) {
	$moddateend = htmlspecialchars($_POST['moddateend']);
} elseif (count($mod) > 1) {
	$moddateend = date('M d Y',strtotime($mod[3].' '.$mod[4].' '.$mod[5]));
} else {
	$moddateend = '';
}

$startdate = explode(' ',$tq->getOpenDateRange());
if (isset($_POST['opendatestart'])) {
	$opendatestart = htmlspecialchars($_POST['opendatestart']);
} elseif (count($startdate) > 1) {
	$opendatestart = date('M d Y',strtotime($startdate[0].' '.$startdate[1].' '.$startdate[2]));
} else {
	$opendatestart = '';
}
if (isset($_POST['opendateend'])) {
	$opendateend = htmlspecialchars($_POST['opendateend']);
} elseif (count($startdate) > 1) {
	$opendateend = date('M d Y',strtotime($startdate[3].' '.$startdate[4].' '.$startdate[5]));
} else {
	$opendateend = '';
}

$enddate = explode(' ',$tq->getCloseDateRange());
if (isset($_POST['closedatestart'])) {
	$closedatestart = htmlspecialchars($_POST['closedatestart']);
} elseif (count($enddate) > 1) {
	$closedatestart = date('M d Y',strtotime($enddate[0].' '.$enddate[1].' '.$enddate[2]));
} else {
	$closedatestart = '';
}
if (isset($_POST['closedateend'])) {
	$closedateend = htmlspecialchars($_POST['closedateend']);
} elseif (count($enddate) > 1) {
	$closedateend = date('M d Y',strtotime($enddate[3].' '.$enddate[4].' '.$enddate[5]));
} else {
	$closedateend = '';
}


include ('forms/TrackerQueryEdit-tpl.php');

?>
