<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for $OBJECT deletion
//
require_once('plugins/tracker/lib/TrackerExtraFieldPeer.php');
require_once('plugins/tracker/lib/TrackerExtraField.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$TrackerExtraField = TrackerExtraFieldPeer::retrieveByPk($_REQUEST['tracker_extra_field_id']);
if (!is_object($TrackerExtraField)) {
	throw new PermissionDeniedException();
}
$Tracker=$TrackerExtraField->getTracker();
if (!is_object($Tracker) || !$Tracker->userCanDelete()) {
	throw new PermissionDeniedException();
}
$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldBrowse').'&amp;tracker_id='.$Tracker->getTrackerID() .'">'. $Lang->getText('TrackerExtraField.Edit') .'</a>');

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerExtraField.DeletePageTitle')
		);

include('forms/TrackerExtraFieldDelete-tpl.php');

?>
