<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once 'plugins/wiki/lib/om/BaseWikiVersion.php';
require_once("plugin/ActionManager.php");
require_once 'lib/core/FilesystemPeer.php';
require_once 'plugins/wiki/lib/WikiPlugin.php';

/** 
 * The skeleton for this class was autogenerated by Propel  * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package plugins.wiki.lib 
 */
class WikiVersion extends BaseWikiVersion {
	private $filesystem_file;
	/**
	 * Stores the object in the database using the Propel methods. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	function save($con = null,$force=false) {
		//need to be able to increment hit count
		if (!$force) {
			if ($this->getWikiPage()->isNew() && !$this->getWikiPage()->userCanCreate()) {
				throw new PermissionDeniedException("Could not create WikiPage object: permission denied");
			} else if (!$this->getWikiPage()->userCanUpdate()) {
				throw new PermissionDeniedException("Could not update WikiPage object: permission denied");
			}
		}

		parent::save($con);
		ActionManager::notify("WIKI_VERSION_SAVE", $this);
	}
	
	public function userCanDelete() {
		return $this->getWikiPage()->userCanDelete();
	}

	public function delete($con = null) {
		// fetch all the filesystem objects related to this version and wipe them out
		if (!$this->userCanDelete()) {
			throw new PermissionDeniedException();
		}
		if (is_object($this->getFile())) {
			$this->getFile()->delete();
		}
		parent::delete($con);
	}

	/**
	 * get the filesystem object associated with this version
	 */
	public function getFile() {
		if (!$this->filesystem_file) {
			$c = new Criteria();
			$c->add(FilesystemPeer::REF_ID,$this->getPrimaryKey());
			$c->add(FilesystemPeer::SECTION,WikiPlugin::SECTION);

			$this->filesystem_file=FilesystemPeer::doSelectOne($c);
		}
		return $this->filesystem_file;
	}
}
?>
