<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-16
 *
 * SOAP plugin for GForge5.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
 

//
//	Artifacts
//
$server->wsdl->addComplexType(
	'Artifact',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'artifact_id' => array('name'=>'artifact_id', 'type' => 'xsd:int'),
		'group_artifact_id' => array('name'=>'group_artifact_id', 'type' => 'xsd:int'),
		'status_id' => array('name'=>'status_id', 'type' => 'xsd:int'),
		'priority' => array('name'=>'priority', 'type' => 'xsd:int'),
		'submitted_by' => array('name'=>'submitted_by', 'type' => 'xsd:int'),
		'assignees' => array('name'=>'assignees', 'type' => 'tns:ArrayOfArtifactAssignee'),
		'open_date' => array('name'=>'open_date', 'type' => 'xsd:int'),
		'close_date' => array('name'=>'close_date', 'type' => 'xsd:int'),
		'summary' => array('name'=>'summary', 'type' => 'xsd:string'),
		'details' => array('name'=>'details', 'type' => 'xsd:string'),
		'sort_order' => array('name'=>'sort_order', 'type' => 'xsd:int'),
		'parent_id' => array('name'=>'parent_id', 'type' => 'xsd:int'),
		'extra_fields'=>array('name'=>'extra_fields', 'type' => 'tns:ArrayOfArtifactExtraFieldsData'),
		'dependencies'=>array('name'=>'dependencies', 'type' => 'tns:ArrayOfArtifactDependency')
	)
);

//ArrayOfArtifact
$server->wsdl->addComplexType(
	'ArrayOfArtifact',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(
		array(
			'ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:Artifact[]'
		)
	),
	'tns:Artifact'
);

//ArtifactAssignee
$server->wsdl->addComplexType(
	'ArtifactAssignee',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'user_id' => array('name'=>'user_id', 'type' => 'xsd:int'),
		'percent_effort' => array('name'=>'percent_effort', 'type' => 'xsd:int')
	)
);


//ArrayOfArtifactAssignee
$server->wsdl->addComplexType(
	'ArrayOfArtifactAssignee',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(
		array(
			'ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:ArtifactAssignee[]'
		)
	),
	'tns:ArtifactAssignee'
);

//ArtifactDependency
$server->wsdl->addComplexType(
	'ArtifactDependency',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'related_artifact_id' => array('name'=>'related_artifact_id', 'type' => 'xsd:int'),
		'link_type' => array('name'=>'link_type', 'type' => 'xsd:string')
	)
);

//ArrayOfArtifactDependency
$server->wsdl->addComplexType(
	'ArrayOfArtifactDependency',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(
		array(
			'ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:ArtifactDependency[]'
		)
	),
	'tns:ArtifactDependency'
);

$server->wsdl->addComplexType(
	'ArtifactExtraFieldsData',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'extra_field_id' => array('name'=>'extra_field_id', 'type' => 'xsd:int'),
		'field_data' => array('name'=>'field_data', 'type' => 'xsd:string')
	)
);

$server->wsdl->addComplexType(
	'ArrayOfArtifactExtraFieldsData',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(
		array(
		'ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:ArtifactExtraFieldsData[]')
	),
	'tns:ArtifactExtraFieldsData'
);

?>
