  <?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists User
//
require_once('core/UserPeer.php');
require_once('core/UserProjectPeer.php');
require_once('core/User.php');
require_once('html/Paginator.php');
require_once('html/HTMLWidget.php');

//$limit = 50; // users per page
$session = Session::getSession();
$Lang = $session->getLanguage();
$default_sort_by = UserPeer::LASTNAME;

require_once('html/templates/SiteAdminTemplate.php');
$theme = new SiteAdminTemplate();

$params = array(
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('SiteAdmin.UserMaint')
		);
$theme->header($params);


if (array_key_exists('user_name_search',$_REQUEST)) {
	$user_name_search = $_REQUEST['user_name_search'];
} else {
	$user_name_search = null;
}
if (array_key_exists('project_id',$_REQUEST)) {
	$project_id = addslashes($_REQUEST['project_id']);
} else {
	$project_id = null;
}

$columns = array(
	UserPeer::FIRSTNAME.'||'.UserPeer::LASTNAME => $Lang->getText('SiteAdmin.UserApprove.FullName'),
	UserPeer::STATUS => $Lang->getText('User.StatusName'),
	$Lang->getText('Edit'),
	$Lang->getText('SiteAdmin.UserList.Activate'),
	$Lang->getText('SiteAdmin.UserList.Delete')
);

// Retrieve the objects array
if (isset($_REQUEST['project_members'])) {
	$total = 0;
	$con = Propel::getConnection(UserPeer::DATABASE_NAME);
	$sqlCount = "SELECT COUNT(*) FROM \"user\" WHERE user_id IN (SELECT user_id FROM user_project 
	UNION SELECT member_user_id AS user_id FROM usergroup_user WHERE usergroup_id IN (SELECT user_id FROM user_project))";

	$stmtCount = $con->createStatement();
	$rsCount = $stmtCount->executeQuery($sqlCount);
	if ($rsCount->next()) {
		$total = $rsCount->getInt('count');
	}
	$paginator = new Paginator('br_user', -1, $total, $default_sort_by, $columns);
	$sqlAux = $paginator->getSQL();

	$sql = "SELECT * FROM \"user\" WHERE user_id IN (SELECT user_id FROM user_project
	UNION SELECT member_user_id AS user_id FROM usergroup_user WHERE usergroup_id IN (SELECT user_id FROM user_project)) {$sqlAux}";

	$stmt = $con->createStatement();
	$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);	

	$arr = UserPeer::populateObjects($rs);
} elseif ($user_name_search) {
	// search by criteria
	$crit = new Criteria();
	// don't show unapproved users
	$crit->add(UserPeer::STATUS, User::STATUS_PENDING_APPROVAL, Criteria::NOT_EQUAL);
	$crit->add(UserPeer::IS_GROUP, false);
	// Add the OR
	$cton1 = $crit->getNewCriterion(UserPeer::UNIX_NAME, $user_name_search.'%', Criteria::ILIKE); 
	$cton2 = $crit->getNewCriterion(UserPeer::LASTNAME, $user_name_search.'%', Criteria::ILIKE); 
	$cton1->addOr($cton2); 
	$crit->add($cton1);	
	$crit->addAscendingOrderByColumn(UserPeer::LASTNAME);

	$total = UserPeer::doCount($crit);
	$paginator = new Paginator('br_user', -1, $total, $default_sort_by, $columns);
	$paginator->addPageClauses($crit);

	$arr = UserPeer::doSelect($crit);

} elseif($project_id) {
	// get users for project
	$crit = new Criteria();
	// don't show unapproved users
	$crit->add(UserPeer::STATUS, User::STATUS_PENDING_APPROVAL, Criteria::NOT_EQUAL);
	$crit->add(UserPeer::IS_GROUP, false);
	$crit->addJoin(UserPeer::USER_ID, UserProjectPeer::USER_ID);
	$crit->add(UserProjectPeer::PROJECT_ID, $project_id);

	$total = UserPeer::doCount($crit);
	$paginator = new Paginator('br_user', -1, $total, $default_sort_by, $columns);
	$paginator->addPageClauses($crit);

	$arr = UserPeer::doSelect($crit);
} else {
	// all users
	$crit = new Criteria();
	// don't show unapproved users
	$crit->add(UserPeer::STATUS, User::STATUS_PENDING_APPROVAL, Criteria::NOT_EQUAL);
	$crit->add(UserPeer::IS_GROUP, false);

	$total = UserPeer::doCount($crit);
	$paginator = new Paginator('br_user', -1, $total, $default_sort_by, $columns);
	$paginator->addPageClauses($crit);

	$arr = UserPeer::doSelect($crit);
}

$theader = array();

/*$theader[] = $Lang->getText('SiteAdmin.UserApprove.FullName');
$theader[] = $Lang->getText('User.StatusName');
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('SiteAdmin.UserList.Activate');
$theader[] = $Lang->getText('SiteAdmin.UserList.Delete');*/
//$theader[] = $Lang->getText('SiteAdmin.UserList.Suspend');



$theader = $paginator->getSortableTableHeaders($theme);

//echo $paginator->showLimitOptions();

echo $theme->tableTop($theader);

if (count($arr) == 0) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('User.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		// Don't show the "Nobody" user
		if ($item->getUserId() == User::UNDEFINED_USER_ID) {
			continue;
		}
		
		$trow = array();
		$trow[0]=$item->getUserLink();
		$trow[1]='';
		$trow[2]='<a href="'. GFUrl::getUrl()->currentBaseUrl('UserEdit').'&amp;user_id='.$item->getID() .'">'. $Lang->getText('Edit') .'</a>';
		$trow[3]='<a href="'. GFUrl::getUrl()->currentBaseURL('UserEditAction',array('_action'=>'activate','user_id'=>$item->getID(),'return_to'=>'UserBrowse')) . '">' .Language::getSessText('SiteAdmin.UserList.Activate'). '</a>';
		$trow[4]='<a href="'. GFUrl::getUrl()->currentBaseURL('UserDelete',array('user_id'=>$item->getID())) . '">' .Language::getSessText('SiteAdmin.UserList.Delete') .'</a>';
//		$trow[5]='<a href="'. GFUrl::getUrl()->currentBaseURL('UserEditAction',array('_action'=>'suspend','user_id'=>$item->getID(),'return_to'=>'UserBrowse')) . '">' .Language::getSessText('SiteAdmin.UserList.Suspend'). '</a>';

		$status = $item->getStatus();
		
		if ($status == User::STATUS_ACTIVE) {
			$trow[1]=$Lang->getText('SiteAdmin.UserList.Active');
			$trow[3]='&nbsp;';
		} elseif ($status == User::STATUS_DELETED ) {
			$trow[1]=$Lang->getText('SiteAdmin.UserList.Deleted');
			$trow[4]='&nbsp;';
		} elseif ($status == User::STATUS_SUSPENDED) {
			$trow[1]=$Lang->getText('SiteAdmin.UserList.Suspended');
			$trow[5]='&nbsp;';
		} elseif ($status == User::STATUS_PENDING ) {
			$trow[1]=$Lang->getText('SiteAdmin.UserEdit.Pending');
		} elseif ($status == User::STATUS_PENDING_APPROVAL ) {
			$trow[1]=Language::getSessText('SiteAdmin.UserList.PendingApproval');
			$trow[3]='&nbsp;';
		}
		echo $theme->tableRow($trow, array(), false);
	}
	//echo $theme->listPaginatorRow($paginator);
}

echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('').'">'. $Lang->getText('Common.Back') .'</a>'));

if(isset($paginator) && is_object($paginator)) {
	echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
}

$theme->footer($params);

?>
