<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel A. Perez daniel@gforgegroup.com
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/html/SiteTemplate.php');
require_once('lib/core/FilesystemPeer.php');
require_once('lib/core/FilesystemDownloadPeer.php');

// This prevents a bug with some versions of IE
//Session::getSession()->disableGZHandler();

/**
 * Echoes the header / footer an error message
 *
 */
function download_error($msg) {
	// something wrong in the path
	$theme = new SiteTemplate();
	
	$params = array(
			'feedback' => isset($msg) ? $msg : '',
			'title' => Language::getSessText('Download.DownloadError')
			);
	$theme->header($params);	
	$theme->footer();		
}

// download/section/ref_id/fileid/filename.ext   this is what we should have, and refuse anything else

$components = GFUrl::getUrl()->getRelativeURI();
$arr = explode('/',$components);
if (count($arr)==5) {
	$section = $arr[1];
	$ref_id = $arr[2];
	$file_id = $arr[3];	
	$file_name = urldecode($arr[4]);

	$file = FilesystemPeer::retrieveByPk($file_id);
	if ( (is_object($file)) && ($file->getRefId()==$ref_id) && ($file->getSection()==$section) && ($file->getFileNameSafe()==$file_name) ) {
		$params['section'] = $section;
		$params['ref_id'] = $ref_id;
		$prs = ActionManager::notify('CHECK_DOWNLOAD_PERMS',$params);
		foreach ($prs as $pr) {
			if ($pr->getResult()==true) {
				if ($file->dataValid()) {
					if (GFConf::get('system.redirectDownloads')) {
						$file->incrementDownloadCount();
						header('Location: '.GFConf::get('system.redirectDownloadHost').$file->getRelativeDirPath().'/'.$arr[4]);
						exit;
					} else {
						//download count incresed automatically in DB
						header('Content-type: '.$file->getFileType());
						header('Content-disposition: attachment;');
						//header('Content-disposition: attachment; filename="'.$file_name.'"');
						header("Content-Length: ".$file->getFileSize());					
						$file->dumpFileData();
					}
				} else {
					download_error(Language::getSessText('Download.DataInvalid'));
				}
				exit(0);
			}
		}
		// no plugin answered permission ok
//		download_error('Permission Denied');
		throw new PermissionDeniedException();
	} else {
		download_error(Language::getSessText('Download.ParamsInvalid'));
	}	
} else {
	download_error('Invalid parameter count');
}
?>
