<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a User and saves it to the 
// database
//
require_once('core/User.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$User = $session->getUser();

$errors = array();
$language = Language::getSessLang();

$confirm_hash = substr(md5(rand(1,1000000).time()),0,16);		
		
if (count($errors) == 0) {
	$User->setConfirmHash($confirm_hash);
	$User->setEmailNew($_POST['new_email']);
	
	try {
		$User->save();		
		$User->sendEmailEditEmail();
	} catch (InvalidDataException $ex) {
		$errors = $ex->getErrors();
	}
}

if (count($errors) == 0) {
	
	$url = GFUrl::getUrl();
	GFUrl::redirect($url->currentBaseURL('UserBrowse'), array('feedback' => $language->getText('MyUserEmailEdit.SubmitMsg')));
} else {
	$feedback = implode('<br />', $errors);
	include('UserEmailEdit.php');
}

?>