<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Julian Yerfino jyerfino@gforgegroup.com
 * @date
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/MyTemplate.php');
require_once('lib/core/FilesystemPeer.php');
//require_once('lib/core/UserProjectPeer.php');
require_once('lib/html/HTMLWidget.php');
require_once('lib/core/MyReport.php');
require_once('lib/core/MyReportPeer.php');
require_once('lib/core/MyReportProject.php');
require_once('lib/core/MyReportProjectPeer.php');

$session=Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}

$user = Session::getSession()->getUser();
$Lang = $session->getLanguage();

if(isset($_REQUEST['feedback'])) $feedback = $_REQUEST['feedback'];
if(isset($_REQUEST['report_id'])) {
	$report_id = Validator::sanitizeInt($_REQUEST['report_id']);
	// Fetch report data
	if($report_id != 0) {
		$report = MyReportPeer::retrieveByPK($report_id);
		if(!is_object($report)) {
			throw new InvalidDataException();
		}
	}
	else {
		throw new InvalidDataException();
	}
}
else {
	throw new InvalidDataException();
}

if($report->getUserId() != $user->getUserId()) {
	$parms = array ('feedback'=>$Lang->getText('Report.NotOwner'));
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), $parms);
	exit();
}

if(!isset($_REQUEST['confirmDelete'])) {
	$parms = array ('feedback'=>$Lang->getText('Report.MissingConfirmation'), 'report_id'=>$report_id);
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('ReportDelete'), $parms);
	exit();
}

$report->delete();

$parms = array ('feedback'=>$Lang->getText('Report.ReportDeleted'));
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), $parms);
	exit();

?>
