<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('core/ProjectPeer.php');
require_once('html/HTMLWidget.php');

$session = Session::getSession();
$project = GFUrl::getUrl()->getProject();
$lang = $session->getLanguage();

$feedback = (isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : '');

require_once('html/templates/ProjectAdminTemplate.php');
$template = new ProjectAdminTemplate();
$params = array(
		'project' => $project,
		'feedback' => $feedback,
		'title' => $lang->getText('ProjectAdmin.PluginSettings')
	);
$template->header($params);
?>

<p><h2><?php echo $lang->getText('ProjectAdmin.PluginSettings') ?></h2></p>

<form method="post" action="<?php echo GFUrl::getUrl()->currentBaseUrl('PluginSettingsAction') ?>">
<?php

$params = array('project' => $project);
$settings = ActionManager::notify('GET_PROJECT_SETTINGS_FORM', $params);

foreach ($settings as $setting) {
	$form = $setting->getResult();
	echo "<p>\n";
	echo "<h3>".$form['title']."</h3>\n";
	echo $form['contents'];
	echo "</p>\n";
	echo "<br />";
	echo "<hr />";
}
?>
<br /><br />
<p>
	<?php echo HTMLWidget::button("submit",$lang->getText('submit.edit'),"submit","","")?>
	<?php echo HTMLWidget::button("button",$lang->getText('Common.Back'),"cancel","","javascript:history.go(-1);")?>
<p>
</form>

<?php
$template->footer();
?>
