<?php
/**
 * Gforge 5.0 Project Summary.
 *
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: gf 386 2006-02-01 19:42:23Z marcelo $
 * @author
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/ProjectTemplate.php');
require_once('lib/core/ProjectPeer.php');
require_once('lib/core/ProjectPluginPeer.php');
require_once('lib/core/RolePeer.php');
require_once('lib/core/Role.php');
require_once('lib/core/UserPeer.php');
require_once('lib/core/TroveLinkPeer.php');
require_once('lib/core/TroveCategoryPeer.php');
$project = GFUrl::getUrl()->getProject();
$project_name = $project->getUnixName();

function render_project_tree($projarr,$parent_id,$indent) {
	$indent++;
	if (isset($projarr[$parent_id])) {
		foreach ($projarr[$parent_id] as $prj) {
			echo str_repeat('&nbsp;',$indent*6).$prj->getProjectLink().'<br />';
			render_project_tree($projarr,$prj->getProjectId(),$indent);
		}
	}
}


$template = new ProjectTemplate();
$params = array(
		'selectedbottomtab'	=> 'summary',
		'project' => $project,
		'title'=>'Home',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : '')
	);
$template->header($params);
$theme = Session::getSession()->getTheme(); // get the theme

// Get the home page contents for this project
$contents = $project->getHomepage()->getFileData(false);

// Process any wiki words that might be in there
$wiki = new Wiki('project', $project->getProjectId(), $theme, $project);
$contents = $wiki->processExternalContent($contents, '');

$str = '';
if (stripos($contents, '%%CLASSIC%%') !== false) {
	$prs = ActionManager::notify("BUILD_PROJECT_SUMMARY",array('project'=>$project,'theme'=>$template));
	$class=0;
	$split=false;
	if (count($prs) > 0) {
		$str .= $theme->infoTableTop(Language::getSessText('Project.GeneralSections'));
		$str .= '<table border="0" width="100%"><tr><td valign="top" width="50%">';
		foreach ($prs as $result) {
			if ($class >= ($prs->count()/2)) {
				if (!$split) {
					$str .= '</td><td valign="top" width="50%">';
				}
				$split=true;
			}
			$str .= $result->getResult();
			$class++;
		}
		$str .= '</td></tr></table>';
		$str .= $theme->infoTableBottom();
		$contents = str_replace('%%CLASSIC%%', $str, $contents);
	}
}
if (stripos($contents, '%%NEWS%%') !== false) {
	$news = '';
	$news_prs = ActionManager::notify("BUILD_PROJECT_NEWS_SUMMARY",array('project'=>$project,'theme'=>$template));
	foreach ($news_prs as $result) {
		$news .= $result->getResult();
	}
	
	$contents = str_replace('%%NEWS%%', $news, $contents);
}
if (stripos($contents, '%%ACTIVITY%%') !== false) {
	require_once('html/StatsRenderer.php');

	// Get the latest activity items
	$con = Propel::getConnection(UserPeer::DATABASE_NAME);
	$stmt = $con->createStatement();
	$sql="SELECT * FROM project_activity_vw 
		WHERE project_id=".$project->getProjectId()."
		ORDER BY activity_date DESC LIMIT 15 OFFSET 0";
	$rs = $stmt->executeQuery($sql);
	$renderer = new StatsRenderer($project, $rs);
	$table = $renderer->getStatsTable();
	
	$contents = str_replace('%%ACTIVITY%%', $table, $contents);
}


?>
<table width="100%" border="0">
	<tr>
		<td width="70%" valign="top">
			<?php 
				echo '<div>'.$contents.'</div>'; 
				if ($project->userIsAdmin()) {
					echo '<br />&nbsp;';
					echo HTMLWidget::button("button", Language::getSessText('Project.EditHomepage'),"","","window.location='". GFUrl::getUrl()->projectUrl($project, 'EditHomepage', '', 'admin')."';");
				}
			?>
		</td>
		<td>&nbsp;</td>
		<td nowrap="nowrap" valign="top" width="30%" rowspan="2">
			<?php
			echo $theme->infoTableTop(Language::getSessText('Project.Activity'));
			?>
			<center>
			<img src="<?php echo GFUrl::getURL()->projectURL($project, 'Activity', 'graphs');?>" width="230" height="150" border="0" alt="Activity"/>
			<?php
 			// Show the "Request to join" button only if the user doesn't belong to the project
 			$user = Session::getSession()->getUser();
 			echo "<br />";
 			if (!is_null($user) && !$user->isProjectMember($project)) {
 				echo HTMLWidget::button("button",Language::getSessText('ProjectJoinRequest.AddNew'),"","","window.location='". GFUrl::getUrl()->projectUrl($project, 'ProjectJoinRequestAdd', '')."';");
 			} else {
 				echo HTMLWidget::button("button",Language::getSessText('ProjectJoinRequest.AddNew'),"","","", false);
 			}
			echo '</center>';
			echo $theme->infoTableMiddle(Language::getSessText('Project.DescriptionName'));
			echo nl2br(wordwrap($project->getDescription(),40));
			echo $theme->infoTableMiddle(Language::getSessText('Project.DeveloperInfo'));
			$devs = $project->getMembers();
			if (count($devs) < 1) {
				echo 'No Developers in this Project';
			}
			foreach ($devs as $dev) {
				echo $dev->getUserLink().'<br />';
			}

			if ($project->getRootPath() != '') {
				echo $theme->infoTableMiddle(Language::getSessText('Project.TreeView'));
				$projs=$project->getAllProjectsInTree();
				$projarr=array();
				foreach ($projs as $proj) {
					$projarr[$proj->getParentProjectId()][]=$proj;
				}
				echo render_project_tree($projarr,0,-1);

			}
			echo $theme->infoTableMiddle(Language::getSessText('ProjectAdmin.TroveCategorization'));
			
			
			//
			// Trove categorization
			//
			$trove = TroveLinkPeer::getSelectedCategoriesTree(Project::SECTION, $project->getPrimaryKey());
			if (count($trove) > 0) {
				echo '<ul>';
				foreach ($trove as $trove_root => $data) {
					if (count($data['children']) > 0) {
						echo '<li>'.$data['name'].': ';
						$children_names = array();
						foreach ($data['children'] as $children) {
							$children_names[] = $children->getCategoryName();
						}
						
						echo implode(', <br /> ', $children_names);
						echo '</li>'."\n";
					}
				}
				echo '</ul>';
			} else {
				echo Language::getSessText('Project.NotTroveCat');
			}
			echo $template->infoTableBottom();

			?>
		</td>
	</tr>
</table>
<?php
$template->footer();
?>
