<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Prez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


require_once('wwwlib/search/commonsearch.php');
require_once('html/ProjectTemplate.php');
$project = GFUrl::getUrl()->getProject();
$lang = Session::getSession()->getLanguage();
$template = new ProjectTemplate();

if (isset($_REQUEST['do_search'])) {
	$search=(isset($_REQUEST['search']) ? $_REQUEST['search'] : array());
	$words =(isset($_REQUEST['words']) ? Validator::sanitizeString($_REQUEST['words']) : '');
	$search_params['template'] = $template;
	$search_params['project'] = $project;
	$search_params['search']= $search;
	$search_params['words'] = $words;
	if (isset($_REQUEST['startdate']) && isset($_REQUEST['enddate'])) {
		$search_params['startdate'] = Validator::sanitizeDate($_REQUEST['startdate']);
		$search_params['enddate'] = Validator::sanitizeDate($_REQUEST['enddate']);
	} else {
		if (isset($_REQUEST['startdate']) || isset($_REQUEST['enddate'])) {
			$feedback = 'Date Range Must Include Both Dates';
		}
		$search_params['startdate'] = null;
		$search_params['enddate'] = null;
	}
	$search_params['search_attach'] = (isset($_REQUEST['search_attach']) ? Validator::sanitizeBool($_REQUEST['search_attach']) : false);
} else {
	$words = '';
	$search = array();
}

$params = array(
	'selectedbottomtab'=>'search',
	'project' => $project,
	'title'=>'Search',
	'feedback'=>isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : '')
);	
$template->header($params);

$theader = array('Search Criteria');

if(isset($_REQUEST['search_by']) &&  $_REQUEST['search_by'] == 'tags'){
		  //unset multiselect vars
		  unset($_REQUEST['search']);
}

echo '<script language="javascript" type="text/javascript" src="/datetimepicker.js"></script>';
echo $template->tableTop($theader);
$trow = array();
echo '<form style="display: inline;" action="/gf/project/' . $project->getUnixName() . '/search/" method="POST">';
$trow[0] = '<strong>'.$lang->getText('Search.Keywords').':</strong><br /> <input type="text" size="25" name="words" value="'.$words.'" /><p>';
$trow[0] .= '<strong>'.$lang->getText('Search.In').':</strong><br /> <select multiple name="search[]">';

$prs = ActionManager::notify('BUILD_SEARCH_COMBO',$params);
foreach ($prs as $result) {
	$options = $result->getResult();
	foreach ($options as $option) {
		if (isset($_REQUEST['search']) && array_search($option['value'],$_REQUEST['search']) !== false) {
			$checked = " selected ";
		} else {
			$checked = " ";
		}
		$trow[0] .= '<option' . $checked . 'value="' . $option['value'] . '">' . $option['display'] . '</option>';
	}
}

$trow[0] .= '</select> <br />';
$trow[0] .= '<p><strong>Search By</strong><br />';
$trow[0] .= '<input type="radio" name="search_by" value="keywords" ' . (!isset($_REQUEST['search_by']) || $_REQUEST['search_by'] == 'keywords' ? 'checked' : '' ). '/>' . $lang->getText('Search.Keywords') . '<br />';
$trow[0] .= '<input type="radio" name="search_by" value="tags" ' . (isset($_REQUEST['search_by']) && $_REQUEST['search_by'] == 'tags' ? 'checked' : ''). ' />' . $lang->getText('Tag.TabHeader') .'</p>';
//EXPRESS
//$trow[0] .= '<p><strong>Search Attached Files:</strong><br /><input type="checkbox" name="search_attach" value="1" '.(isset($_REQUEST['search_attach']) ? 'checked="checked"' : '').'/>';
$trow[0] .= '<p><strong>Date Range:</strong><br />
<input id="startdate" type="text" size="11" maxlength="11" name="startdate" value="'.(isset($_REQUEST['startdate']) ? $_REQUEST['startdate'] : '').'"/><a href="javascript:NewCal(\'startdate\',\'MMMddyyyy\')"><img src="/themes/gforge5/images/cal.gif" alt="Pick a date" border="0" height="16" width="16"></a>&nbsp;&nbsp;&nbsp;<input id="enddate" type="text" size="11" maxlength="11" name="enddate" value="'.(isset($_REQUEST['enddate']) ? $_REQUEST['enddate'] : '').'"/><a href="javascript:NewCal(\'enddate\',\'MMMddyyyy\')"><img src="/themes/gforge5/images/cal.gif" alt="Pick a date" border="0" height="16" width="16"></a>';
$trow[0] .= '<p>' . HTMLWidget::button("submit",$language->getSessText('SearchBox.search'),"do_search","","") . '</form>';
echo $template->tableRow($trow,array(),true);
echo $template->tableBottom();

echo '<br /><br />';

if (array_key_exists('do_search',$_REQUEST)) {
	if (strlen($_REQUEST['words'])>0) {
		if(isset($_REQUEST['search_by']) &&  $_REQUEST['search_by'] == 'tags'){
			echo searchTags($search_params);
		} else {

			try {
				$results = ActionManager::notify('DO_SEARCH',$search_params);
				foreach ($results as $result ) {
					echo $result->getResult() . '<br />';
				}
			} catch (SQLException $e) {
				// SQL exception here means that there was a syntax error on the search terms
				echo '<span class="feedback">'.$lang->getText('Search.InvalidSearch').'</span>';
			}
		}
	} else {
		echo "<h2>Empty Search</h2>";
	}
}

$template->footer();
?>
